unit Schema;
interface

uses
  WinMineModele, WinMineControleur,Windows,dialogs, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls;

type
{Taille de minefield + 1 bordure d'1 case initalise  -1}
TMap = array of array of shortint;
{Le champ de mines transform en tableau numrique}
TMineFieldNumeriq = array of array of shortint;
{Schema '121'}
TSchema121a = array[1..3,1..3] of byte;
TSchema121b = array[1..3,1..3] of byte;
TSchema121c = array[1..3,1..3] of byte;
TSchema121d = array[1..3,1..3] of byte;
{Schema '11'}
TSchema11a1 = array[1..3,1..2] of byte;
TSchema11a2 = array[1..3,1..2] of byte;
TSchema11b1  = array[1..2,1..3] of byte;
TSchema11b2  = array[1..2,1..3] of byte;
{Schema '12'}
TSchema12ga  = array[1..3,1..3] of byte;
TSchema12gb  = array[1..3,1..3] of byte;
TSchema12da  = array[1..3,1..3] of byte;
TSchema12db  = array[1..3,1..3] of byte;
TSchema12ba  = array[1..3,1..3] of byte;
TSchema12bb  = array[1..3,1..3] of byte;

const
sch121a: TSchema121a = ((10,10,10),(1,2,1),(20,20,20));
sch121b: TSchema121b = ((20,20,20),(1,2,1),(10,10,10));
sch121c: TSchema121c = ((10,1,20),(10,2,20),(10,1,20));
sch121d: TSchema121d = ((20,1,10),(20,2,10),(20,1,10));

SCh11a1: TSchema11a1 =((10,10),(1,1),(20,20));
SCh11a2: TSchema11a2 =((20,20),(1,1),(10,10));
SCh11b1: TSchema11b1 =((20,1,10),(20,1,10));
SCh11b2: TSchema11b2 =((10,1,20),(10,1,20));

SCh12ga: TSchema12ga =((10,1,20),(10,2,20),(10,20,20));
SCh12gb: TSchema12gb =((20,1,10),(20,2,10),(20,20,10));
SCh12da: TSchema12da =((10,20,20),(10,2,20),(10,1,20));
SCh12db: TSchema12db =((20,20,10),(20,2,10),(20,1,10));
SCh12ba: TSchema12ba =((10,10,10),(20,2,1),(20,20,20));
SCh12bb: TSchema12bb =((20,20,20),(20,2,1),(10,10,10));

var
  Map: TMap;
  MFN:
  TMineFieldNumeriq;
function GetMineFieldNumeriq(var MFN: TMineFieldNumeriq; const MineField:TMineField):boolean;
function InitTMAP(var MAP:TMAP; const MF:TMineFieldNumeriq):boolean;
procedure Affiche(const MFN: TMineFieldNumeriq; memo:TMemo);
procedure AfficheMAP(const MAP: TMAP; memo:TMemo);
//function ChercheSchema121a(out w: word;out h:word; const MAP:TMAP;const sch:TSchema121a ):boolean;
function Cherche2Schema121a(out w: word;out h:word;const MFN: TMineFieldNumeriq;const sch:TSchema121a ):boolean;
function Cherche2Schema121b(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121b ):boolean;
function Cherche2Schema121c(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121c ):boolean;
function Cherche2Schema121d(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121d ):boolean;

function Cherche2Schema11a1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a1 ):boolean;
function Cherche2Schema11a2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a2 ):boolean;
function Cherche2Schema11b1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b1 ):boolean;
function Cherche2Schema11b2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b2 ):boolean;
function Cherche2Schema11c1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a1 ):boolean;
function Cherche2Schema11c2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a2 ):boolean;
function Cherche2Schema11d1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b1 ):boolean;
function Cherche2Schema11d2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b2 ):boolean;

function Cherche2Schema12ga(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12ga ):boolean;
function Cherche2Schema12gb(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12gb ):boolean;
function Cherche2Schema12da(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12da ):boolean;
function Cherche2Schema12db(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12db ):boolean;
function Cherche2Schema12ba(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12ba ):boolean;
function Cherche2Schema12bb(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12bb ):boolean;
Implementation

uses
  Unit1, Unit2;

function GetMineFieldNumeriq(var MFN: TMineFieldNumeriq; const MineField:TMineField):boolean;
var
  i,j:word;
begin
  result := False;
  SetLength(MFN,wmcWidth,wmcHeight);
  for i := 0 to wmcwidth -1 do
    for j := 0 to wmcheight -1 do
    begin
      if ((MineField[i,j].IsClosed = True) and (MineField[i,j].cMarked = msNone)) then   {qd je vais mettre les drapeaux verifier qu'il ny en ai pas deja un!!!}
        MFN[i,j] := 10;
      if ((MineField[i,j].IsClosed = True) and (MineField[i,j].cMarked = msMineMark)) then   {qd je vais mettre les drapeaux verifier qu'il ny en ai pas deja un!!!}
        MFN[i,j] := 20;
      if MineField[i,j].IsClosed = False then
      begin
        MineField[i,j].ciNumberAdjacentMine := GetNumOfMines(i,j);
        MFN[i,j] := MineField[i,j].ciNumberAdjacentMine;
      end;
    end;
  result := True;
end;

procedure Affiche(const MFN: TMineFieldNumeriq; memo:TMemo);
var
  i,j: word;
  Ligne: string;
begin
   Ligne := '';
   for i := 0 to wmcwidth -1 do
   begin
      for j := 0 to wmcheight -1 do
      begin
        Ligne := Ligne + IntTostr(MFN[i,j])+' ';
      end;
      memo.Lines.Add(Ligne);
      memo.Lines.Add(#13#10);
      Ligne := '';
   end;
end;

procedure AfficheMAP(const MAP: TMAP; memo:TMemo);
var
  i,j: word;
  Ligne: string;
begin
   Ligne := '';
   for i := 0 to wmcwidth +1 do
   begin
      for j := 0 to wmcheight +1 do
      begin
        Ligne := Ligne + IntTostr(MAP[i,j])+' ';
      end;
      memo.Lines.Add(Ligne);
      memo.Lines.Add(#13#10);
      Ligne := '';
   end;
end;

function InitTMAP(var MAP:TMAP; const MF:TMineFieldNumeriq):boolean;
var
  i,j: word;
begin
   Result := False;
   SetLength(MAP,wmcWidth+2,wmcHeight+2);
   {Initialise tout le tableau  -1}
   for i := 0 to wmcwidth +1 do
    for j := 0 to wmcheight +1 do
    begin
      MAP[i,j] := -1;
    end;
   {Initialise le tableau. Laisse une bordure d'1 case  -1}
   for i := 1 to wmcwidth do
     for j := 1 to wmcheight do
     begin
       MAP[i,j] := MF[i-1,j-1];
     end;
   Result := True;
end;

{function ChercheSchema121a(out h:word; out w: word;const MAP:TMAP;const sch:TSchema121a ):boolean;
var
  i,j,k: word;
  somme : smallint;
  Flag : boolean;
begin
   result := False;
   somme := 0;
   Flag := False;
   for i := 1 to wmcwidth  - High(sch) do
     for j := 1 to wmcheight  - sizeof(sch[1]) do
     begin
       for k := low(sch[1]) to high(sch[1]) do
       begin
         if (sch[1][k] xor MAP[i,j+k-1]) <0 then
         begin
           somme := +1;
           break
         end;
         somme := somme + (sch[1][k] xor MAP[i,j+k-1]) + (sch[2][k] xor MAP[i+1,j+k-1]);
         if MAP[i+2,j+k-1] <> 10 then Flag := True;
       end;
     if ( (somme = 0) and Flag) then
     begin
         h := i;
         w:= j;
         result := True;
     end;
       somme := 0;
     end;

end;       }

{-------------------------------Schema '121'-----------------------------------------------------------------}
function Cherche2Schema121a(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121a ):boolean;
var
  i,j,k: word;
  somme : smallint;
  Flag : boolean;
begin
   result := False;
   somme := 0;
   Flag := False;
   for i := 0 to wmcwidth   - High(sch) do
     for j := 0 to wmcheight  - sizeof(sch[1]) do
     begin
       for k := low(sch[1]) to high(sch[1]) do
       begin
         if (sch[1][k] xor MFN[i,j+k-1]) <0 then
         begin
           somme := +1;
           break
         end;
         somme := somme + (sch[1][k] xor MFN[i,j+k-1]) + (sch[2][k] xor MFN[i+1,j+k-1]);
         if ((MFN[i+2,j+k-1] <> 10)   or (MFN[i+2,j+k-1] <> 20))


         then Flag := True else Flag := False;
       end;
     if ( (somme = 0) and Flag) then
     begin
         w := i;
         h := j;
         result := True;
         break;
     end;
       somme := 0;
     end;

end;

function Cherche2Schema121b(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121b ):boolean;
var
  i,j,k: word;
  somme : smallint;
  Flag : boolean;
begin
   result := False;
   somme := 0;
   Flag := False;
   for i := 0 to wmcwidth   - High(sch) do
     for j := 0 to wmcheight  - sizeof(sch[1]) do
     begin
       for k := low(sch[1]) to high(sch[1]) do
       begin
         if (sch[3][k] xor MFN[i,j+k-1]) <0 then
         begin
           somme := +1;
           break
         end;
         somme := somme + (sch[3][k] xor MFN[i+2,j+k-1]) + (sch[2][k] xor MFN[i+1,j+k-1]);
         if ((MFN[i,j+k-1] <> 10)) then Flag := True else Flag := False;
       end;
     if ( (somme = 0) and Flag) then
     begin
         w := i+2;
         h := j;
         result := True;
         break;
     end;
       somme := 0;
     end;
end;

function Cherche2Schema121c(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121c ):boolean;
var
  i,j,k: word;
  somme : smallint;
  Flag : boolean;
begin
   result := False;
   somme := 0;
   Flag := False;
   for i := 0 to wmcwidth  - High(sch) do
     for j := 0 to wmcheight  - sizeof(sch[1]) do
     begin
       for k := low(sch[1]) to (high(sch[1])-1) do
       begin
         if (sch[3][k] xor MFN[i,j+k-1]) <0 then
         begin
           somme := +1;
           break
         end;
         somme := somme + (sch[1][k] xor MFN[i,j+k-1]) + (sch[2][k] xor MFN[i+1,j+k-1])+ (sch[3][k] xor MFN[i+2,j+k-1]);
         if (((MFN[i,j+2] <> 10) or (MFN[i,j+2] <> 20))
         and ((MFN[i+1,j+2] <> 10) or (MFN[i+1,j+2] <> 20))
         and ((MFN[i+2,j+2] <> 10) or (MFN[i+2,j+2] <> 20)))then Flag := True;
       end;
     if ( (somme = 0) and Flag) then
     begin
         w := i;
         h := j;
         result := True;
         break;
     end;
       somme := 0;
     end;
end;

function Cherche2Schema121d(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema121d ):boolean;
var
  i,j,k: word;
  somme : smallint;
  Flag : boolean;
begin
   result := False;
   somme := 0;
   Flag := False;
   for i := 0 to wmcwidth   - High(sch) do
     for j := 0 to wmcheight  - sizeof(sch[1]) do
     begin
       for k := (low(sch[1])+1) to high(sch[1]) do
       begin
         somme := somme + (sch[1][k] xor MFN[i,j+k-1]) + (sch[2][k] xor MFN[i+1,j+k-1])+ (sch[3][k] xor MFN[i+2,j+k-1]);
         if ( ((MFN[i,j] <> 10) or (MFN[i,j] <> 20))
         and ((MFN[i+1,j] <> 10) or (MFN[i+1,j] <> 20))
         and ((MFN[i+2,j] <> 10) or (MFN[i+2,j] <> 20)))
         then Flag := True;
       end;
     if ( (somme = 0) and Flag) then
     begin
         w := i;
         h := j+2;
         result := True;
         break;
     end;
       somme := 0;
     end;
end;

{---------------------------------------Schema '11'-----------------------------------------------------------}
function Cherche2Schema11a1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a1 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   j := wmcHeight -1;
   for i := 0 to (wmcwidth -1  - High(sch)-1) do
   begin
     for k := low(sch) to (high(sch)-1) do
     begin
       somme := somme + (sch[k][1] xor MFN[i+k-1,j-1]) + (sch[k][2] xor MFN[i+k-1,j]);

       if ((MFN[i+k,j-1] <> 10) and (MFN[i+k,j] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+1;
         h := j-2;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema11a2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a2 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   j := wmcHeight -1;
   for i := 0 to (wmcwidth -1  - High(sch)-1) do
   begin
     for k := (low(sch)+1) to high(sch) do
     begin
       somme := somme + (sch[k][1] xor MFN[i+k-1,j-1]) + (sch[k][2] xor MFN[i+k-1,j]);
       if ((MFN[i+k-1,j-1] <> 10) and (MFN[i+k-1,j] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+1;
         h := j-2;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema11b1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b1 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   i := 0;
   for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
   begin
     for k := (low(sch)) to high(sch) do
     begin
       somme := somme + (sch[k][2] xor MFN[i+k-1,j+1]) + (sch[k][3] xor MFN[i+k-1,j+2]);
       if ((MFN[i,j] <> 10) and (MFN[i+1,j] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+2;
         h := j+1;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;


function Cherche2Schema11b2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b2 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   i := 0;
   for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
   begin
     for k := (low(sch)) to high(sch) do
     begin
       somme := somme + (sch[k][2] xor MFN[i+k-1,j+1]) + (sch[k][1] xor MFN[i+k-1,j]);
       if ((MFN[i,j+2] <> 10) and (MFN[i+1,j+2] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+2;
         h := j+1;
         result := True;
         break;
       end;
   {j := wmcHeight -1;
   for i := 0 to (wmcwidth -1  - High(sch)) do
   begin
     for k := (low(sch)+1) to high(sch) do
     begin
       somme := somme + (sch[k][1] xor MFN[i+k-1,j-1]) + (sch[k][2] xor MFN[i+k-1,j]);
       if ((MFN[i+k-1,j-1] <> 10) and (MFN[i+k-1,j] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+1;
         h := j-2;
         result := True;
         break;
       end;  }
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema11c1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a1 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   j := 0;
   for i := 0 to (wmcwidth -1  - High(sch)-1) do
   begin
     for k := low(sch) to (high(sch)-1) do
     begin
       somme := somme + (sch[k][1] xor MFN[i+k-1,j]) + (sch[k][2] xor MFN[i+k-1,j+1]);
       if ((MFN[i+k,j] <> 10) and (MFN[i+k,j+1] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+1;
         h := j+2;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;
function Cherche2Schema11c2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11a2 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   j := 0;
   for i := 0 to (wmcwidth -1  - High(sch)-1) do
   begin
     for k := (low(sch)+1) to high(sch) do
     begin
       somme := somme + (sch[k][1] xor MFN[i+k-1,j]) + (sch[k][2] xor MFN[i+k-1,j+1]);
       if ((MFN[i+k-1,j] <> 10) and (MFN[i+k-1,j+1] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i+1;
         h := j+2;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;


function Cherche2Schema11d1(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b1 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   i := wmcWidth-1;
   for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
   begin
     for k := (low(sch)) to high(sch) do
     begin
       somme := somme + (sch[k][2] xor MFN[i-2+k,j+1]) + (sch[k][3] xor MFN[i-2+k,j+2]);
       if ((MFN[i,j] <> 10) and (MFN[i-1,j] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i-2;
         h := j+1;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema11d2(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema11b2 ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   i := wmcWidth-1;
   for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
   begin
     for k := (low(sch)) to high(sch) do
     begin
       somme := somme + (sch[k][2] xor MFN[i-2+k,j+1]) + (sch[k][1] xor MFN[i-2+k,j]);
       if ((MFN[i,j+2] <> 10) and (MFN[i-1,j+2] <> 10)) then Flag := True;
     end;

       if((somme = 0) and Flag) then
       begin
         w := i-2;
         h := j+1;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema12ga(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12ga ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   i := 0;
   for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
   begin
     for k := (low(sch)) to high(sch) do
       somme := somme + (sch[k][1] xor MFN[i+k-1,j]);
     for K := (low(sch)) to high(sch)-1 do
       somme := somme + (sch[k][2] xor MFN[i+k-1,j+1]);
     if ((MFN[i+2,j+1] <> 10) and (MFN[i+2,j+1] <> 20)
     and (MFN[i,j+2] <> 10) and (MFN[i,j+2] <> 20)
     and (MFN[i+1,j+2] <> 10) and (MFN[i+1,j+2] <> 20)
     and (MFN[i+2,j+2] <> 10) and (MFN[i+2,j+2] <> 20) )
      then Flag := True;


       if((somme = 0) and Flag) then
       begin
         w := i+2;
         h := j;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;


function Cherche2Schema12gb(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12gb ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   i := 0;
   for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
   begin
     for k := (low(sch)) to high(sch) do
       somme := somme + (sch[k][3] xor MFN[i+k-1,j+2]);
     for K := (low(sch)) to high(sch)-1 do
       somme := somme + (sch[k][2] xor MFN[i+k-1,j+1]);
     if ((MFN[i+2,j+1] <> 10) and (MFN[i+2,j+1] <> 20)
     and (MFN[i,j] <> 10) and (MFN[i,j] <> 20)
     and (MFN[i+1,j] <> 10) and (MFN[i+1,j] <> 20)
     and (MFN[i+2,j] <> 10) and (MFN[i+2,j] <> 20) )
      then Flag := True;


       if((somme = 0) and Flag) then
       begin
         w := i+2;
         h := j+2;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema12da(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12da ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
  somme := 0;
  flag := false;
  i := wmcWidth -1;
  for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
  begin
    for k := (low(sch)) to high(sch) do
       somme := somme + (sch[k][1] xor MFN[i+k-3,j]);
    for K := (low(sch)+1) to high(sch) do
       somme := somme + (sch[k][2] xor MFN[i+k-3,j+1]);
    if ((MFN[i-2,j+1] <> 10) and (MFN[i-2,j+1] <> 20)
    and (MFN[i,j+2] <> 10) and (MFN[i,j+2] <> 20)
    and (MFN[i-1,j+2] <> 10) and (MFN[i-1,j+2] <> 20)
    and (MFN[i-2,j+2] <> 10) and (MFN[i-2,j+2] <> 20) )
    then Flag := True;


       if((somme = 0) and Flag) then
       begin
         w := i-2;
         h := j;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;


function Cherche2Schema12db(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12db ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
  somme := 0;
  flag := false;
  i := wmcWidth -1;
  for j := 0 to (wmcHeight -1  - High(sch[1])-1) do
  begin
    for k := (low(sch)) to high(sch) do
       somme := somme + (sch[k][3] xor MFN[i+k-3,j+2]);
    for K := (low(sch)+1) to high(sch) do
       somme := somme + (sch[k][2] xor MFN[i+k-3,j+1]);
    if ((MFN[i-2,j+1] <> 10) and (MFN[i-2,j+1] <> 20)
    and (MFN[i,j] <> 10) and (MFN[i,j] <> 20)
    and (MFN[i-1,j] <> 10) and (MFN[i-1,j] <> 20)
    and (MFN[i-2,j] <> 10) and (MFN[i-2,j] <> 20) )
    then Flag := True;


       if((somme = 0) and Flag) then
       begin
         w := i-2;
         h := j+2;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema12ba(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12ba ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   j := wmcHeight -1-2;
   for i := 0 to (wmcwidth   - High(sch)) do
   begin
     for k := low(sch[1]) to (high(sch[1])) do
       somme := somme + (sch[1][k] xor MFN[i,j+k-1]) ;
     for K := (low(sch[1])+1) to high(sch[1]) do
       somme := somme + (sch[2][k] xor MFN[i+1,j+k-1]);

    if ((MFN[i+1,j] <> 10) and (MFN[i+1,j] <> 20)
    and (MFN[i+2,j] <> 10) and (MFN[i+2,j] <> 20)
    and (MFN[i+2,j+1] <> 10) and (MFN[i+2,j+1] <> 20)
    and (MFN[i+2,j+2] <> 10) and (MFN[i+2,j+2] <> 20) )
    then Flag := True;

       if((somme = 0) and Flag) then
       begin
         w := i;
         h := j;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

function Cherche2Schema12bb(out w: word;out h:word; const MFN: TMineFieldNumeriq;const sch:TSchema12bb ):boolean;
var
  i,j,k: word;
  somme : smallint;
  flag: boolean;
begin
  result := False;
   somme := 0;
   flag := false;
   j := wmcHeight -1-2;
   for i := 0 to (wmcwidth   - High(sch)) do
   begin
     for k := low(sch[1]) to (high(sch[1])) do
       somme := somme + (sch[3][k] xor MFN[i+2,j+k-1]) ;
     for K := (low(sch[1])+1) to high(sch[1]) do
       somme := somme + (sch[2][k] xor MFN[i+1,j+k-1]);

    if ((MFN[i+1,j] <> 10) and (MFN[i+1,j] <> 20)
    and (MFN[i,j] <> 10) and (MFN[i,j] <> 20)
    and (MFN[i,j+1] <> 10) and (MFN[i,j+1] <> 20)
    and (MFN[i,j+2] <> 10) and (MFN[i,j+2] <> 20) )
    then Flag := True;

       if((somme = 0) and Flag) then
       begin
         w := i+2;
         h := j;
         result := True;
         break;
       end;
     somme := 0;
     Flag := False;
   end;
end;

end.
