unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, shellapi,WinMineModele, WinMineControleur,Schema, Menus, syncobjs, ComCtrls, ExtCtrls,
  Buttons, Spin, unit2;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    lbDeb: TLabel;
    lbInt: TLabel;
    lbExp: TLabel;
    lbDebTime: TLabel;
    lbIntTime: TLabel;
    lbExpTime: TLabel;
    lbDebWin: TLabel;
    lbIntWin: TLabel;
    lbExpWin: TLabel;
    Button7: TButton;
    SpinEdit1: TSpinEdit;
    EdtName: TEdit;
    Button3: TButton;
    Nouveau: TButton;
    Button9: TButton;
    RefreshScore: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ShowHide: TButton;
    Memo1: TMemo;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Label4: TLabel;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Clickgauche1Click(Sender: TObject);
    procedure Clickdroit1Click(Sender: TObject);
    procedure DoubleClickdroit1Click(Sender: TObject);
    procedure Rinitialiser1Click(Sender: TObject);
    procedure Rcuperer1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure NouveauClick(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button7Click(Sender: TObject);

    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure ShowHideClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    function InitMinField():boolean;
    procedure RunAlgo();
  end;

var
  Form1     :TForm1;
  HWinmine  :HWND;
  nbMines   :word;
  NbCellMarked: word;
  IsWinner  :boolean;
  { Score }
  NbrePartiesJouees: smallint;
  ScoreCumule: smallint;
  MoyenneScore: smallInt;
  ggg,hhh:hwnd;
  tpsMoyen:extended;
  tps:cardinal;
  nbrepartiesgagnees: smallint;
  hsc,wsc: word;

function clickintelligent2():boolean;

function IsFinish(const ItemIndexCombo:byte; out IsWinner:boolean):boolean;
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var

  NewColumn: TListColumn;
begin
if HWinmine = 0 then
    ShellExecute(0, 'open', 'winmine.exe', Nil, Nil, SW_NORMAL);
  sleep(200);   //sinon  FindWindowEx ne trouve pas la fenetre foreground

  HWinmine := FindWindowEx(0,0,'Dmineur', nil);
  if HWinmine = 0 then showmessage('erreur FindWindowEx');

{ComboBox1}
ComboBox1.Items.Clear;
ComboBox1.Items.AddObject('Dbutant', TObject(lsDebutant));
ComboBox1.Items.AddObject('Intermdiaire', TObject(lsIntermediaire));
ComboBox1.Items.AddObject('Expert', TObject(lsExpert));
ComboBox1.ItemIndex := 0;
ComboBox1Change(self);

nbMines := GetNumOfAllMines();
Width := 381;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
ClipCursor(nil);

SendMessage(HWinmine, WM_CLOSE, 0, 0);   //Ferme le dmineur.
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
if HWinMine <> 0 then
 if combobox1.ItemIndex = 3 then
  SetMenuItemPersonnalise()
 else
   SelectMenuItem(HWinmine,ord(TLevelStyle(combobox1.Items.Objects[combobox1.ItemIndex]))+2);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caFree;
end;

procedure TForm1.Clickgauche1Click(Sender: TObject);
var
  rec: TRect;
  p: TPoint;
  _Color: TCOLORREF;
  Dc: HDC;
begin

  GetwindowRect(HWinmine, rec);
  GetCursorPos(P);
  SetCursorPos( rec.Left +6+16, rec.Top+16 +74+14);
  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
  Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0); // On simule l'appui sur le bouton
  Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0); // On simule le relchement du bouton
  DC := GetDC(0);
  _Color := GetPixel(Dc,rec.Left+6 +16,rec.Top+16 +74+14);
  ShowMessage(inttohex(TColor(_color),8));
  ReleaseDc(0, Dc);
  SetCursorPos(P.X, P.Y);
end;

procedure TForm1.Clickdroit1Click(Sender: TObject);
var
  p, pp:TPoint;
begin
  GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  SendRightClick1(HWinMine, pp.x, pp.y);
  SetCursorPos(p.x, p.y);
end;

procedure TForm1.DoubleClickdroit1Click(Sender: TObject);
var
  p, pp:TPoint;
begin
  GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  SendDoubleRightClick1(HWinMine, pp.x+5, pp.y+5);
  SetCursorPos(p.x, p.y);
end;

procedure TForm1.Rinitialiser1Click(Sender: TObject);
begin
   CleanScore(HWinMine);
end;

procedure TForm1.Rcuperer1Click(Sender: TObject);
var
  scores: TScoresTab;
begin
  ReadScore(HWInMine,scores);
  lbDebTime.Caption := scores[1].TimeElapsed;
  lbDebWin.Caption := scores[1].Winner;
  lbIntTime.Caption := scores[2].TimeElapsed;
  lbIntWin.Caption := scores[2].Winner;
  lbExpTime.Caption := scores[3].TimeElapsed;
  lbExpWin.Caption := scores[3].Winner;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Rcuperer1Click(self);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  rec: TRect;
  p, pp: TPoint;
  ClipCurs: TRect;
begin
  Windows.GetClientRect(HWinmine, rec);
  pp.x := rec.left+5;
  pp.y := rec.top-10;
  Windows.ClientToScreen(HWinmine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);

  SetCursorPos( pp.x , pp.y );
  SendClick_V1(HWinmine, pp.x, pp.y);
  SendClick_v2(pp.x,pp.y + 20);
  SetCursorPos(P.X, P.Y); // On remet le curseur  sa position d'origine
  ClipCursor(nil);
end;

procedure TForm1.NouveauClick(Sender: TObject);
var
  rec: TRect;
  p, pp: TPoint;
  ClipCurs: TRect;
begin
  Windows.GetClientRect(HWinmine, rec);
  pp.x := rec.left+5;
  pp.y := rec.top-10;
  Windows.ClientToScreen(HWinmine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);

  SetCursorPos( pp.x , pp.y );
  SendClick_V1(HWinmine, pp.x, pp.y);
  SendClick_v2(pp.x,pp.y + 20);
  SetCursorPos(P.X, P.Y); // On remet le curseur  sa position d'origine
  ClipCursor(nil);
end;


procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  ShowMessage('coucou');
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  i:smallint;
  chronodepart:cardinal;
  chronoarrivee:cardinal;
begin
  ScoreCumule := 0;
  Form1.StatusBar1.Panels[0].Text := '';
  Form1.StatusBar1.Panels[1].Text := '';

  for i := 0 to spinedit1.value-1 do
  begin
  sleep(500);
    chronodepart := gettickcount;
    RunAlgo;

    chronoarrivee := gettickcount - chronodepart;

    
    if IsWinner then
    begin
     Inc(nbrepartiesgagnees);
     tps := tps + chronoarrivee;
    end;
  end;
  if nbrepartiesgagnees >0 then
  begin
  tpsmoyen := tps / nbrepartiesgagnees;
  Form1.StatusBar1.Panels[0].Text :='Nombre de parties gagnes : ' + IntToStr(nbrepartiesgagnees);
  Form1.StatusBar1.Panels[1].Text := 'Temps moyen : ' +floattoStr(tpsmoyen)+ ' ms.';
  end;
  nbrepartiesgagnees :=0;
  NbrePartiesJouees  :=0;
  ScoreCumule        :=0;
  MoyenneScore       :=0;
  tpsmoyen           :=0;
  tps                :=0;
  IsWinner           := False;
end;



function clickintelligent2():boolean;
var
SumFrameNum:integer;
frame1: tCframe;
i,j :integer;
pp:TPoint;
CColor: byte;
min:word;
indice:word;
trouve:boolean;
r: word;
begin
 result := false;
 min := 100;
 trouve := false;
 pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);
  if GetListCellClose(MineField, wmcHeight, wmcWidth, LCC) then
  begin
    for i := 0 to High(LCC) do
    begin
      GetCFrame(LCC[i]^,frame1);
      SumFrameNum := DoSumFrame(frame1);
      if  (SumFrameNum <=5) then
      if  (frame1[1]<>nil ) then
      if  (frame1[6]<>nil ) then
      if ((Frame1[1]^.ciNumberAdjacentMine = 1) or (Frame1[6]^.ciNumberAdjacentMine = 1)) then       //((SumFrameNum <>0) and
      begin
      trouve := True;
        min := SumframeNum;
        indice := i;
        break;
      end;
    end;
    if ((not trouve) or (min = 100)) then
    begin
      for i := 0 to High(LCC) do
      begin
        GetCFrame(LCC[i]^,frame1);
        SumFrameNum := DoSumFrame(frame1);
        if ((SumFrameNum =0) and (SumFrameNum < min)) then
        begin
          min := SumframeNum;
          indice := i;
        end;
      end;
    end;
    if trouve then
    begin
    SendClick_v1(HWinMine, pp.x + LCC[indice]^.cx*16 +8, pp.y + LCC[indice]^.cy*16 +8);

    LCC[indice]^.IsClosed := False;
    CColor := GetNumOfMines(LCC[indice]^.cx, LCC[indice]^.cy);

    if (CColor = 99) then
      result := false
    else
      result := true;

     { for j := 0 to high(lcc) do
      lcc[j] := nil;  }
    //  form1.Memo1.Lines.Add(IntToStr(LCC[i]^.cx +1 ) + ' ' + (IntToStr(LCC[i]^.cy +1))+ ' : ' + inttostr(SumFrameNum));
    end;
  end;

end;
function IsFinish(const ItemIndexCombo:byte; out IsWinner:boolean):boolean;
var
  p, pp    :TPoint;
  CColor   :TCOLORREF;
  Dc       :HDC;
  x1,y1    :smallint;
  dx, dy   :smallint;
begin
  //GetCursorPos(p);
  pp := GetFieldScreenOrigine(HWinMine);
  DC := GetDC(0);
  case ItemIndexCombo of
  0:
    begin
      result := false;
      x1 := 4;
      y1 := 0;
      dx := -2;
      dy := -35;
      //SetCursorPos(pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      CColor := GetPixel(Dc,pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      if tcolor(ccolor) = $00000000 then
      begin
        result := true;
        IsWinner := true;
        Inc(ScoreCumule);
      end;
      dx := 0;
      dy := -33;
      CColor := GetPixel(Dc,pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      if tcolor(ccolor) = $00000000 then
      begin
        result := true;
        IsWinner := false;
        //SetCursorPos(pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      end;

    end;
  1:
    begin
      result := false;
      x1 := 7;
      y1 := 0;
      dx := +5;
      dy := -35;
      CColor := GetPixel(Dc,pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      if tcolor(ccolor) = $00000000 then
      begin
        result := true;
        IsWinner := true;
        Inc(ScoreCumule);
      end;
      dx := +7;
      dy := -33;
      CColor := GetPixel(Dc,pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      if tcolor(ccolor) = $00000000 then
      begin
        result := true;
        IsWinner := false;
      end;
    end;
  2:
    begin
      result := false;
      x1 := 14;
      y1 := 0;
      dx := +5;
      dy := -35;
      CColor := GetPixel(Dc,pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      if tcolor(ccolor) = $00000000 then
      begin
        result := true;
        IsWinner := true;
        Inc(ScoreCumule);
      end;
      dx := +7;
      dy := -33;
      CColor := GetPixel(Dc,pp.x+8+16*x1+dx,pp.y+8+16*y1+dy);
      if tcolor(ccolor) = $00000000 then
      begin
        result := true;
        IsWinner := false;
      end;
    end
    else
    begin
      result := false;
    end;
    
    ReleaseDc(0, Dc);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  scores: TScoresTab;
begin
  CleanScore(HWinMine);
  ReadScore(HWInMine,scores);
  lbDebTime.Caption := scores[1].TimeElapsed;
  lbDebWin.Caption := scores[1].Winner;
  lbIntTime.Caption := scores[2].TimeElapsed;
  lbIntWin.Caption := scores[2].Winner;
  lbExpTime.Caption := scores[3].TimeElapsed;
  lbExpWin.Caption := scores[3].Winner;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  rec: TRect;
  p, pp: TPoint;
  ClipCurs: TRect;
begin
  Windows.GetClientRect(HWinmine, rec);
  pp.x := rec.left+5;
  pp.y := rec.top-10;
  Windows.ClientToScreen(HWinmine, pp);
  GetCursorPos(P);
  ClipCurs.TopLeft := Point(pp.x,pp.y);
  ClipCurs.BottomRight := Point(pp.x,pp.y);
  ClipCursor(@ClipCurs);

  SetCursorPos( pp.x , pp.y );
  SendClick_V1(HWinmine, pp.x, pp.y);
  SendClick_v2(pp.x,pp.y + 20);
  SetCursorPos(P.X, P.Y); // On remet le curseur  sa position d'origine
  ClipCursor(nil);
end;

Function TForm1.InitMinField():boolean;
var
  spec1,spec2: word;
  h,w       :string;
  i,j,k,l   :integer;
  pp        :TPoint;
  CColor    :byte;
  x, y      :integer;
  ListItem  :TListItem;
  Frame     :TCFrame;
  count     :word;
  compteur  :word;
  s,p       :smallint;

begin
   StatusBar1.Panels[0].Text := '';
   case combobox1.ItemIndex of
   0: nbMines := 10;
   1: nbMines := 40;
   2: nbMines := 99;
   else
    raise Exception.Create('erreur nbre de mines');
   end;
  NbCellMarked := 0;
  GetSizeOfFieldMine(h,w);
  ComboBox1Change(nil);
  wmcWidth := StrToInt(w);
  wmcHeight := StrToInt(h);
  result := True;
end;


procedure TForm1.RunAlgo;
var
  spec1,spec2: word;
  //h,w       :string;
  i,j,k,l   :integer;
  pp        :TPoint;
  CColor    :byte;
  x, y      :integer;
  ListItem  :TListItem;
  Frame     :TCFrame;
  count     :word;
  compteur  :word;
  s,p       :smallint;

  countcase   :byte;
  indicemap   :byte;
  countcase2  :byte;
  indicemap2i :byte;
  indicemap2j :byte;
  boucle      :byte;
  boucle2     :byte;
  countcase3  :byte;
  indicemap3i :byte;
  indicemap3j :byte;
  indicemap3k :byte;

  countcase4  :byte;
  indicemap4i :byte;
  indicemap4j :byte;
  indicemap4k :byte;
  indicemap4l :byte;

  countcase5  :byte;
  indicemap5i :byte;
  indicemap5j :byte;
  indicemap5k :byte;
  indicemap5l :byte;
  indicemap5m :byte;

  countcase6  :byte;
  indicemap6i :byte;
  indicemap6j :byte;
  indicemap6k :byte;
  indicemap6l :byte;
  indicemap6m :byte;
  indicemap6n :byte;

  sortie1     :word;
  sortie2     :word;
  timeelapsed :cardinal;
  timestart   :cardinal;
  SaisieScores: hwnd;

  scx,scy:word;
  pTempCell: PCell;
  SumFrameNum: word;  {somme des chiffres du cadre d'une cellule}
  SumFrameNum2: word;
  FenetreGagne: HWND;
  IsSchemaFound: boolean;
  label debut;
begin
  Form1.InitMinField();
  timestart:= gettickcount;
  SetLength(MineField,wmcWidth,wmcHeight);
  for i :=0 to wmcWidth -1  do
    for j :=0 to wmcHeight -1 do
    begin
      with MineField[i,j] do
      begin
        cx := i;
        cy := j;
        IsClosed := True;
        cMarked :=  msNone;
      end;
    end;
  boucle2 := 0;

 //debut:                                   {LABEL DEBUT}
{---------------------------------------------
     Clique au hasard
----------------------------------------------}
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);
  //Windows.SetFocus(HWinMine);
 Randomize;
  compteur := 0;
  IsWinner := False;
 repeat
    x := Random(wmcWidth);
    y := 0;//Random(wmcHeight);
    if MineField[x,y].IsClosed then
    begin
    SendClick_v1(HWinMine, pp.x + x*16 +8, pp.y + y*16 +8);
    MineField[x,y].IsClosed := False;
    MineField[x,y].ciNumberAdjacentMine := GetNumOfMines(x, y);
    CColor := GetNumOfMines(x, y);//faut tester drapeau rouge
    if ((CColor = 99) and not (MineField[x,y].cMarked = msMineMark ))then
    begin
    IsWinner := false;
    exit;
    end;
    if CColor = 0 then break;
    GetCFrame(MineField[x,y], Frame);
    for k := 0 to 7 do
    begin
      if ( (frame[k]<>nil) and not(Frame[k]^.IsClosed) ) then
        Inc(compteur);
    end;
    for i :=0 to 7 do
    Frame[i] := nil;
    end;

  until CColor = 99;





  {  SendClick_v1(HWinMine, pp.x + 4*16 +8, pp.y + 0*16 +8);
    MineField[4,0].IsClosed := False;
    MineField[4,0].ciNumberAdjacentMine := GetNumOfMines(4, 0);
    CColor := GetNumOfMines(4, 0);//faut tester drapeau rouge
    if ((CColor = 99) and not (MineField[4,0].cMarked = msMineMark ))then
    begin
    IsWinner := false;
    exit;
    end;
    if (CColor = 1) then
    begin
      SendClick_v1(HWinMine, pp.x + 4*16 +8, pp.y + 1*16 +8);
      MineField[4,1].IsClosed := False;
      MineField[4,1].ciNumberAdjacentMine := GetNumOfMines(4, 1);
      CColor := GetNumOfMines(4, 1);//faut tester drapeau rouge
      if ((CColor = 99) and not (MineField[4,1].cMarked = msMineMark ))then
      begin
        IsWinner := false;
        exit;
      end;
      if (CColor = 1) then
      begin
        SendClick_v1(HWinMine, pp.x + 4*16 +8, pp.y + 2*16 +8);
        MineField[4,2].IsClosed := False;
        MineField[4,2].ciNumberAdjacentMine := GetNumOfMines(4, 2);
        SendClick_v1(HWinMine, pp.x + 3*16 +8, pp.y + 2*16 +8);
        MineField[3,2].IsClosed := False;
        MineField[3,2].ciNumberAdjacentMine := GetNumOfMines(3, 2);
        SendClick_v1(HWinMine, pp.x + 5*16 +8, pp.y + 2*16 +8);
        MineField[5,2].IsClosed := False;
        MineField[5,2].ciNumberAdjacentMine := GetNumOfMines(5, 2);
      end;

    SendClick_v1(HWinMine, pp.x + 0*16 +8, pp.y + 6*16 +8);
    MineField[0,6].IsClosed := False;
    MineField[0,6].ciNumberAdjacentMine := GetNumOfMines(0, 6);
    CColor := GetNumOfMines(4, 2);//faut tester drapeau rouge
    if ((CColor = 99) and not (MineField[0,6].cMarked = msMineMark ))then
    begin
    IsWinner := false;
    exit;
    end;
    end;      }

    {SendClick_v1(HWinMine, pp.x + 4*16 +8, pp.y + 2*16 +8);
    MineField[4,2].IsClosed := False;
    MineField[4,2].ciNumberAdjacentMine := GetNumOfMines(4, 2);
    CColor := GetNumOfMines(4, 2);//faut tester drapeau rouge
    if ((CColor = 99) and not (MineField[4,2].cMarked = msMineMark ))then
    begin
    IsWinner := false;
    exit;
    end; }

  



  debut:
 { while not IsFinish(Combobox1.ItemIndex, IsWinner) do
  begin   }
  if boucle2 >= 20 then exit;//if boucle2 >= 3 then exit;
  for i :=0 to 7 do
    Frame[i] := nil;

 for boucle := 0 to 5 do
 begin
    if nbMines = 0 then break;
    countcase   := 0;
    indicemap   := 0;

    countcase2  := 0;
    indicemap2i := 0;
    indicemap2j := 0;

    countcase3  := 0;
    indicemap3i := 0;
    indicemap3j := 0;
    indicemap3k := 0;

    countcase4  := 0;
    indicemap4i := 0;
    indicemap4j := 0;
    indicemap4k := 0;
    indicemap4l := 0;

    countcase5  := 0;
    indicemap5i := 0;
    indicemap5j := 0;
    indicemap5k := 0;
    indicemap5l := 0;
    indicemap5m := 0;

    countcase6  := 0;
    indicemap6i := 0;
    indicemap6j := 0;
    indicemap6k := 0;
    indicemap6l := 0;
    indicemap6m := 0;
    indicemap6n := 0;

    { Cherche les bombes et place les flags}
    for i :=0 to wmcWidth -1  do
    begin
      for j :=0 to wmcHeight -1 do
      begin
        with MineField[i,j] do
        begin
          IsClosed := IsCellOpen(i,j);
          if not IsClosed then            //avec chaque case ouverte faire...
          begin
            ciNumberAdjacentMine := GetNumOfMines(i,j);
            if ciNumberAdjacentMine = 1 then              //si case 1
            begin
              GetCFrame(MineField[i,j], frame);
              for k := 0 to 7 do
              begin
                if ( (frame[k]<>nil )  and  (frame[k]^.IsClosed)) then
                begin
                  Inc(countcase);
                   if countcase = 1 then  indicemap := k;
                 end;
              end;
              if countcase = 1 then
              begin
                pp := GetFieldScreenOrigine(HWinMine);
                SetForegroundWindow(HWinMine);
                Windows.SetFocus(HWinMine);
                if GetMark(frame[indicemap]^.cx,frame[indicemap]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap]^.cx*16 +8, pp.y + frame[indicemap]^.cy*16 +8);
                  frame[indicemap]^.cMarked := msMineMark;
                  frame[indicemap]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
              end;
               for s :=0 to 7 do
                 frame[s] := nil;
            end;   //fin de si case 1

            if ciNumberAdjacentMine = 2 then              //si case 2
            begin
              GetCFrame(MineField[i,j], frame);
              for k := 0 to 7 do
              begin
                if ( (frame[k]<>nil )  and  (frame[k]^.IsClosed)) then
                begin
                  Inc(countcase2);
                  if countcase2 = 1 then  indicemap2i := k;
                  if countcase2 = 2 then  indicemap2j := k;
                 end;
              end;
              if countcase2 = 2 then
              begin
                pp := GetFieldScreenOrigine(HWinMine);
                SetForegroundWindow(HWinMine);
                Windows.SetFocus(HWinMine);
                if GetMark(frame[indicemap2i]^.cx,frame[indicemap2i]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap2i]^.cx*16 +8, pp.y + frame[indicemap2i]^.cy*16 +8);
                  frame[indicemap2i]^.cMarked := msMineMark;
                  frame[indicemap2i]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap2j]^.cx,frame[indicemap2j]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap2j]^.cx*16 +8, pp.y + frame[indicemap2j]^.cy*16 +8);
                  frame[indicemap2j]^.cMarked := msMineMark;
                  frame[indicemap2j]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
              end;
               for s :=0 to 7 do
                 frame[s] := nil;
            end;  //fin de si case 2

            if ciNumberAdjacentMine = 3 then              //si case 3
            begin

              GetCFrame(MineField[i,j], frame);
              for k := 0 to 7 do
              begin
                if ( (frame[k]<>nil )  and  (frame[k]^.IsClosed)) then     //si case fermee
                begin
                  Inc(countcase3);
                  if countcase3 = 1 then  indicemap3i := k;
                  if countcase3 = 2 then  indicemap3j := k;
                  if countcase3 = 3 then  indicemap3k := k;
                 end;
              end;
              if countcase3 = 3 then
              begin
                pp := GetFieldScreenOrigine(HWinMine);
                SetForegroundWindow(HWinMine);
                Windows.SetFocus(HWinMine);
                if GetMark(frame[indicemap3i]^.cx,frame[indicemap3i]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap3i]^.cx*16 +8, pp.y + frame[indicemap3i]^.cy*16 +8);
                  frame[indicemap3i]^.cMarked := msMineMark;
                  frame[indicemap3i]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap3j]^.cx,frame[indicemap3j]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap3j]^.cx*16 +8, pp.y + frame[indicemap3j]^.cy*16 +8);
                  frame[indicemap3j]^.cMarked := msMineMark;
                  frame[indicemap3j]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap3k]^.cx,frame[indicemap3k]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap3k]^.cx*16 +8, pp.y + frame[indicemap3k]^.cy*16 +8);
                  frame[indicemap3k]^.cMarked := msMineMark;
                  frame[indicemap3k]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
              end;
               for s :=0 to 7 do
                 frame[s] := nil;
            end;  //fin de si case 3

            if ciNumberAdjacentMine = 4 then              //si case 4
            begin
              countcase4 :=0;
              GetCFrame(MineField[i,j], frame);
              for k := 0 to 7 do
              begin
                if ( (frame[k]<>nil )  and  (frame[k]^.IsClosed)) then     //si case fermee
                begin
                  Inc(countcase4);
                  if countcase4 = 1 then  indicemap4i := k;
                  if countcase4 = 2 then  indicemap4j := k;
                  if countcase4 = 3 then  indicemap4k := k;
                  if countcase4 = 4 then  indicemap4l := k;
                 end;
              end;
              if countcase4 = 4 then
              begin
                pp := GetFieldScreenOrigine(HWinMine);
                SetForegroundWindow(HWinMine);
                Windows.SetFocus(HWinMine);
                if GetMark(frame[indicemap4i]^.cx,frame[indicemap4i]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap4i]^.cx*16 +8, pp.y + frame[indicemap4i]^.cy*16 +8);
                  frame[indicemap4i]^.cMarked := msMineMark;
                  frame[indicemap4i]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap4j]^.cx,frame[indicemap4j]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap4j]^.cx*16 +8, pp.y + frame[indicemap4j]^.cy*16 +8);
                  frame[indicemap4j]^.cMarked := msMineMark;
                  frame[indicemap4j]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap4k]^.cx,frame[indicemap4k]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap4k]^.cx*16 +8, pp.y + frame[indicemap4k]^.cy*16 +8);
                  frame[indicemap4k]^.cMarked := msMineMark;
                  frame[indicemap4k]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap4l]^.cx,frame[indicemap4l]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap4l]^.cx*16 +8, pp.y + frame[indicemap4l]^.cy*16 +8);
                  frame[indicemap4l]^.cMarked := msMineMark;
                  frame[indicemap4l]^.IsClosed := true;
                  Inc(NbCellMarked);
                end;
              end;
            end;  //fin de si case 4

            if ciNumberAdjacentMine = 5 then              //si case 5
            begin
              countcase5 :=0;
              GetCFrame(MineField[i,j], frame);
              for k := 0 to 7 do
              begin
                if ( (frame[k]<>nil )  and  (frame[k]^.IsClosed)) then     //si case fermee
                begin
                  Inc(countcase5);
                  if countcase5 = 1 then  indicemap5i := k;
                  if countcase5 = 2 then  indicemap5j := k;
                  if countcase5 = 3 then  indicemap5k := k;
                  if countcase5 = 4 then  indicemap5l := k;
                  if countcase5 = 5 then  indicemap5m := k;
                 end;
              end;
              if countcase5 = 5 then
              begin
                pp := GetFieldScreenOrigine(HWinMine);
                SetForegroundWindow(HWinMine);
                Windows.SetFocus(HWinMine);
                if GetMark(frame[indicemap5i]^.cx,frame[indicemap5i]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap5i]^.cx*16 +8, pp.y + frame[indicemap5i]^.cy*16 +8);
                  frame[indicemap5i]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap5j]^.cx,frame[indicemap5j]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap5j]^.cx*16 +8, pp.y + frame[indicemap5j]^.cy*16 +8);
                  frame[indicemap5j]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap5k]^.cx,frame[indicemap5k]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap5k]^.cx*16 +8, pp.y + frame[indicemap5k]^.cy*16 +8);
                  frame[indicemap5k]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap5l]^.cx,frame[indicemap5l]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap5l]^.cx*16 +8, pp.y + frame[indicemap5l]^.cy*16 +8);
                  frame[indicemap5l]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap5m]^.cx,frame[indicemap5m]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap5m]^.cx*16 +8, pp.y + frame[indicemap5m]^.cy*16 +8);
                  frame[indicemap5m]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
              end;
            end;  //fin de si case 5

            if ciNumberAdjacentMine = 6 then              //si case 6
            begin
              countcase6 :=0;
              GetCFrame(MineField[i,j], frame);
              for k := 0 to 7 do
              begin
                if ( (frame[k]<>nil )  and  (frame[k]^.IsClosed)) then     //si case fermee
                begin
                  Inc(countcase6);
                  if countcase6 = 1 then  indicemap6i := k;
                  if countcase6 = 2 then  indicemap6j := k;
                  if countcase6 = 3 then  indicemap6k := k;
                  if countcase6 = 4 then  indicemap6l := k;
                  if countcase6 = 5 then  indicemap6m := k;
                  if countcase6 = 6 then  indicemap6n := k;
                 end;
              end;
              if countcase6 = 6 then
              begin
                pp := GetFieldScreenOrigine(HWinMine);
                SetForegroundWindow(HWinMine);
                Windows.SetFocus(HWinMine);
                if GetMark(frame[indicemap6i]^.cx,frame[indicemap6i]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap6i]^.cx*16 +8, pp.y + frame[indicemap6i]^.cy*16 +8);
                  frame[indicemap6i]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap6j]^.cx,frame[indicemap6j]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap6j]^.cx*16 +8, pp.y + frame[indicemap6j]^.cy*16 +8);
                  frame[indicemap6j]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap6k]^.cx,frame[indicemap6k]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap6k]^.cx*16 +8, pp.y + frame[indicemap6k]^.cy*16 +8);
                  frame[indicemap6k]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap6l]^.cx,frame[indicemap6l]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap6l]^.cx*16 +8, pp.y + frame[indicemap6l]^.cy*16 +8);
                  frame[indicemap6l]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap6m]^.cx,frame[indicemap6m]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap6m]^.cx*16 +8, pp.y + frame[indicemap6m]^.cy*16 +8);
                  frame[indicemap6m]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
                if GetMark(frame[indicemap6n]^.cx,frame[indicemap6n]^.cy) = 0 then
                begin
                  SendRightClick1(HWinMine, pp.x + frame[indicemap6n]^.cx*16 +8, pp.y + frame[indicemap6n]^.cy*16 +8);
                  frame[indicemap6n]^.cMarked := msMineMark;
                  Inc(NbCellMarked);
                end;
              end;
            end;  //fin de si case 6

          end;
          countcase    := 0;
          indicemap    := 0;
          indicemap2i  := 0;
          indicemap2j  := 0;
          countcase2   := 0;
          countcase3   := 0;
          indicemap3i  := 0;
          indicemap3j  := 0;
          indicemap3k  := 0;

          countcase4   := 0;
          indicemap4i  := 0;
          indicemap4j  := 0;
          indicemap4k  := 0;
          indicemap4l  := 0;

          countcase5   := 0;
          indicemap5i  := 0;
          indicemap5j  := 0;
          indicemap5k  := 0;
          indicemap5l  := 0;
          indicemap5m  := 0;

          countcase6  := 0;
          indicemap6i := 0;
          indicemap6j := 0;
          indicemap6k := 0;
          indicemap6l := 0;
          indicemap6m := 0;
          indicemap6n := 0;
        end;      //fin de with MineField
      end;
   end;
   // FIN DE MARQUES
   {----------------------------------------------}

   countcase    := 0;
   indicemap    := 0;
   indicemap2i  := 0;
   indicemap2j  := 0;
   countcase2   := 0;
   countcase3   :=0;
   indicemap3i  := 0;
   indicemap3j  := 0;
   indicemap3k  := 0;
   countcase4   := 0;
   indicemap4i  := 0;
   indicemap4j  := 0;
   indicemap4k  := 0;
   indicemap4l  := 0;
   countcase5   := 0;
   indicemap5i  := 0;
   indicemap5j  := 0;
   indicemap5k  := 0;
   indicemap5l  := 0;
   indicemap5m  := 0;
   countcase6  := 0;
   indicemap6i := 0;
   indicemap6j := 0;
   indicemap6k := 0;
   indicemap6l := 0;
   indicemap6m := 0;
   indicemap6n := 0;

   for i :=0 to 7 do
      frame[i] := nil;

   {ouvre les cases}
   for i :=0 to wmcWidth -1  do
   begin
     for j :=0 to wmcHeight -1 do
       begin
         with MineField[i,j] do
         begin
           IsClosed := IsCellOpen(i,j);
           if not IsClosed then    //pour chaque case ouverte du plateau faire...
           begin
             ciNumberAdjacentMine := GetNumOfMines(i,j);
             if ciNumberAdjacentMine = 1 then         //si case 1
             begin
               GetCFrame(MineField[i,j], frame);
               for k := 0 to 7 do
               try
                 if ( (frame[k]<>nil)  and  (frame[k]^.IsClosed) and (frame[k]^.cMarked = msMineMark)) then
                  begin
                    countcase := countcase +1;
                    if countcase = 1 then  indicemap := k;
                  end;
                except
                raise Exception.Create('bug condition case1');
                end;
               for k := 0 to 7 do
               begin
                 if ( (countcase=1)and(k <> indicemap)and (frame[k]<>nil ) and (frame[k]^.IsClosed)  and (frame[k]^.cMarked <> msMineMark)) then
                 begin
                   pp := GetFieldScreenOrigine(HWinMine);
                   SetForegroundWindow(HWinMine);
                   Windows.SetFocus(HWinMine);

                   SendClick_v1(HWinMine, pp.x + frame[k]^.cx*16 +8, pp.y + frame[k]^.cy*16 +8);
                   frame[k]^.IsClosed:= false;
                 end;
               end;
             end;    //fin de si case 1

             if ciNumberAdjacentMine = 2 then         //si case 2
             begin
               GetCFrame(MineField[i,j], frame);
               for k := 0 to 7 do
                 if ( (frame[k]<>nil)  and  (frame[k]^.IsClosed) and (frame[k]^.cMarked = msMineMark)) then
                  begin
                    countcase2 := countcase2 +1;
                    if countcase2 = 1 then  indicemap2i := k;
                    if countcase2 = 2 then  indicemap2j := k;
                  end;
               for k := 0 to 7 do
               begin
                 if ( (countcase2=2) and
                      (k <> indicemap2i) and
                      (k <> indicemap2j) and
                      (frame[k]<>nil ) and
                      (frame[k]^.IsClosed) and
                      (frame[k]^.cMarked <> msMineMark)) then
                 begin
                   pp := GetFieldScreenOrigine(HWinMine);
                   SetForegroundWindow(HWinMine);
                   Windows.SetFocus(HWinMine);

                   SendClick_v1(HWinMine, pp.x + frame[k]^.cx*16 +8, pp.y + frame[k]^.cy*16 +8);
                   frame[k]^.IsClosed:= false;
                 end;
               end;
             end;

             if ciNumberAdjacentMine = 3 then         //si case 3
             begin
               GetCFrame(MineField[i,j], frame);
               for k := 0 to 7 do
                 if ( (frame[k]<>nil)  and  (frame[k]^.IsClosed) and (frame[k]^.cMarked = msMineMark)) then
                  begin
                    countcase3 := countcase3 +1;
                    if countcase3 = 1 then  indicemap3i := k;
                    if countcase3 = 2 then  indicemap3j := k;
                    if countcase3 = 3 then  indicemap3k := k;
                  end;
               for k := 0 to 7 do
               begin
                 if ( (countcase3=3) and
                      (k <> indicemap3i) and
                      (k <> indicemap3j) and
                      (k <> indicemap3k) and
                      (frame[k]<>nil ) and
                      (frame[k]^.IsClosed) and
                      (frame[k]^.cMarked <> msMineMark)) then
                 begin
                   pp := GetFieldScreenOrigine(HWinMine);
                   SetForegroundWindow(HWinMine);
                   Windows.SetFocus(HWinMine);

                   SendClick_v1(HWinMine, pp.x + frame[k]^.cx*16 +8, pp.y + frame[k]^.cy*16 +8);
                   frame[k]^.IsClosed:= false;
                 end;
               end;
              end;   //fin de si case 3

             if ciNumberAdjacentMine = 4 then         //si case 4
             begin
               GetCFrame(MineField[i,j], frame);
               for k := 0 to 7 do
                 if ( (frame[k]<>nil)  and  (frame[k]^.IsClosed) and (frame[k]^.cMarked = msMineMark)) then
                  begin
                    countcase4 := countcase4 +1;
                    if countcase4 = 1 then  indicemap4i := k;
                    if countcase4 = 2 then  indicemap4j := k;
                    if countcase4 = 3 then  indicemap4k := k;
                    if countcase4 = 4 then  indicemap4l := k;
                  end;
               for k := 0 to 7 do
               begin
                 if ( (countcase4=4) and
                      (k <> indicemap4i) and
                      (k <> indicemap4j) and
                      (k <> indicemap4k) and
                       (k <> indicemap4l) and
                      (frame[k]<>nil ) and
                      (frame[k]^.IsClosed) and
                      (frame[k]^.cMarked <> msMineMark)) then
                 begin
                   pp := GetFieldScreenOrigine(HWinMine);
                   SetForegroundWindow(HWinMine);
                   Windows.SetFocus(HWinMine);

                   SendClick_v1(HWinMine, pp.x + frame[k]^.cx*16 +8, pp.y + frame[k]^.cy*16 +8);
                   frame[k]^.IsClosed:= false;
                 end;
               end;
              end;      //fin de si case 4

             if ciNumberAdjacentMine = 5 then         //si case 5
             begin
               GetCFrame(MineField[i,j], frame);
               for k := 0 to 7 do
                 if ( (frame[k]<>nil)  and  (frame[k]^.IsClosed) and (frame[k]^.cMarked = msMineMark)) then
                  begin
                    countcase5 := countcase5 +1;
                    if countcase5 = 1 then  indicemap5i := k;
                    if countcase5 = 2 then  indicemap5j := k;
                    if countcase5 = 3 then  indicemap5k := k;
                    if countcase5 = 4 then  indicemap5l := k;
                  end;
               for k := 0 to 7 do
               begin
                 if ( (countcase5=5) and
                      (k <> indicemap5i) and
                      (k <> indicemap5j) and
                      (k <> indicemap5k) and
                      (k <> indicemap5l) and
                      (k <> indicemap5m) and
                      (frame[k]<>nil ) and
                      (frame[k]^.IsClosed) and
                      (frame[k]^.cMarked <> msMineMark)) then
                 begin
                   pp := GetFieldScreenOrigine(HWinMine);
                   SetForegroundWindow(HWinMine);
                   Windows.SetFocus(HWinMine);
                   sleep(1000);
                   SendClick_v1(HWinMine, pp.x + frame[k]^.cx*16 +8, pp.y + frame[k]^.cy*16 +8);
                   frame[k]^.IsClosed:= false;
                   break;
                 end;
               end;
              end;      //fin de si case 5

               if ciNumberAdjacentMine = 6 then         //si case 6
             begin
               GetCFrame(MineField[i,j], frame);
               for k := 0 to 7 do
                 if ( (frame[k]<>nil)  and  (frame[k]^.IsClosed) and (frame[k]^.cMarked = msMineMark)) then
                  begin
                    countcase6 := countcase6 +1;
                    if countcase6 = 1 then  indicemap6i := k;
                    if countcase6 = 2 then  indicemap6j := k;
                    if countcase6 = 3 then  indicemap6k := k;
                    if countcase6 = 4 then  indicemap6l := k;
                    if countcase6 = 5 then  indicemap6m := k;
                  end;
               for k := 0 to 7 do
               begin
                 if ( (countcase6=6) and
                      (k <> indicemap6i) and
                      (k <> indicemap6j) and
                      (k <> indicemap6k) and
                      (k <> indicemap6l) and
                      (k <> indicemap6m) and
                      (k <> indicemap6n) and
                      (frame[k]<>nil ) and
                      (frame[k]^.IsClosed) and
                      (frame[k]^.cMarked <> msMineMark)) then
                 begin
                   pp := GetFieldScreenOrigine(HWinMine);
                   SetForegroundWindow(HWinMine);
                   Windows.SetFocus(HWinMine);
                   sleep(1000);
                   SendClick_v1(HWinMine, pp.x + frame[k]^.cx*16 +8, pp.y + frame[k]^.cy*16 +8);
                   frame[k]^.IsClosed:= false;
                   break;
                 end;
               end;
              end;      //fin de si case 6
           end;
           countcase   := 0;
           indicemap   := 0;
           indicemap2i := 0;
           indicemap2j := 0;
           countcase2  := 0;
           countcase3  := 0;
           indicemap3i := 0;
           indicemap3j := 0;
           indicemap3k := 0;
           countcase4  := 0;
           indicemap4i := 0;
           indicemap4j := 0;
           indicemap4k := 0;
           indicemap4l := 0;
           countcase5   := 0;
           indicemap5i  := 0;
           indicemap5j  := 0;
           indicemap5k  := 0;
           indicemap5l  := 0;
           indicemap5m  := 0;
           countcase6  := 0;
           indicemap6i := 0;
           indicemap6j := 0;
           indicemap6k := 0;
           indicemap6l := 0;
           indicemap6m := 0;
           indicemap6n := 0;
         end; //end with MineField
       end;
   end;

   // fin d'ouverture des cases
 end; // fin de boucle 50

  if  (HWinMine <> getforegroundwindow)  then
  begin
  sleep(100);

    FenetreGagne  := FindWindowEx(0,0,'#32770',0);
    ggg :=  FindWindowEx(FenetreGagne,0,0,0);
    SetForegroundWindow(FenetreGagne);
    sleep(200);
    SendText(ggg, EdtName.Text);
    PostMessage(FenetreGagne, WM_KEYDOWN,VK_TAB, 0);
    PostMessage(FenetreGagne, WM_KEYUP,VK_TAB, 0);
    PostMessage(FenetreGagne, WM_KEYDOWN,VK_RETURN, 0);
    PostMessage(FenetreGagne, WM_KEYUP,VK_RETURN, 0);
  end;


  if  (HWinMine <> getforegroundwindow)  then
  begin
  sleep(100);
    FenetreGagne  := FindWindowEx(0,0,'#32770',0);
    ggg :=  FindWindowEx(FenetreGagne,0,0,0);
    SetForegroundWindow(FenetreGagne);
    sleep(200);
    PostMessage(FenetreGagne, WM_KEYDOWN,VK_TAB, 0);
    PostMessage(FenetreGagne, WM_KEYUP,VK_TAB, 0);
    PostMessage(FenetreGagne, WM_KEYDOWN,VK_RETURN, 0);
    PostMessage(FenetreGagne, WM_KEYUP,VK_RETURN, 0);
    //Button8Click(self);
  end;

  if NbCellMarked = nbMines then
  begin
    for i :=0 to wmcWidth -1  do
      for j :=0 to wmcHeight -1 do
      begin
        with MineField[i,j] do
        begin
          if not IsFinish(Combobox1.ItemIndex, IsWinner) then
            SendClick_v1(HWinMine, pp.x + MineField[i,j].cx*16 +8, pp.y + MineField[i,j].cy*16 +8)
          else
            exit;
        end;
      end;
  end;

  if  IsFinish(Combobox1.ItemIndex, IsWinner) then  exit;

  {rafraichir les donnes du champs de mines}
  for i :=0 to wmcWidth -1  do
    begin
      for j :=0 to wmcHeight -1 do
      begin
        with MineField[i,j] do
        begin
          IsClosed := IsCellOpen(i,j);
        end;
      end;
    end;
 {  for i := 0 to 2 do    //scan 3 fois  pour etre sur?
   begin    }
  {----------------------Rechercher schema----------------------------------------------------------------------}
  IsSchemaFound := False;

  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema12ba(Wsc,Hsc,MFN, sch12ba)then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin    sleep(2000);
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked); sleep(1000);
    end;
  end;

  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema12bb(Wsc,Hsc,MFN, sch12bb)then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin    sleep(2000);
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked); sleep(1000);
    end;
  end;

  {12da}
  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema12da(Wsc,Hsc,MFN, sch12da) then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
  end;
  {12db}
  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema12db(Wsc,Hsc,MFN, sch12db) then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
  end;


  {12ga}
  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema12ga(Wsc,Hsc,MFN, sch12ga) then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
  end;
  {12gb}
  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema12gb(Wsc,Hsc,MFN, sch12gb) then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin    sleep(2000);
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
  end;
 // showmessage('debut schema');
  {-----------Schema11-------------------------------------------------------}



   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11d1(Wsc,Hsc,MFN, sch11b1 ) then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
     if ((MineField[scx,scy].IsClosed)
     or (MineField[scx,scy-1].IsClosed)
     or (MineField[scx,scy+1].IsClosed)) then
     begin
     with MineField[scx,scy] do
     begin
       cx := scx;
       cy := scy;
       IsClosed := False;
     end;

     SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
     with MineField[scx,scy-1] do
     begin
       cx := scx;
       cy := scy-1;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy-1].cx*16 +8, pp.y + MineField[scx,scy-1].cy*16 +8);
     with MineField[scx,scy+1] do
     begin
       cx := scx;
       cy := scy+1;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy+1].cx*16 +8, pp.y + MineField[scx,scy+1].cy*16 +8);
     end
     else
        IsSchemaFound := False;
  end;

   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11d2(Wsc,Hsc,MFN, sch11b2 ) then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
     if ((MineField[scx,scy].IsClosed)
     or (MineField[scx,scy-1].IsClosed)
     or (MineField[scx,scy+1].IsClosed)) then
     begin
     with MineField[scx,scy] do
     begin
       cx := scx;
       cy := scy;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
     with MineField[scx,scy-1] do
     begin
       cx := scx;
       cy := scy-1;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy-1].cx*16 +8, pp.y + MineField[scx,scy-1].cy*16 +8);
     with MineField[scx,scy+1] do
     begin
       cx := scx;
       cy := scy+1;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy+1].cx*16 +8, pp.y + MineField[scx,scy+1].cy*16 +8);
     end
     else
       IsSchemaFound := False;
   end;

   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11c1(Wsc,Hsc,MFN, sch11a1 ) then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
     if ((MineField[scx,scy].IsClosed)
     or (MineField[scx-1,scy].IsClosed)
     or (MineField[scx+1,scy].IsClosed)) then
     begin
     with MineField[scx,scy] do
     begin
       cx := scx;
       cy := scy;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    with MineField[scx-1,scy] do
      begin
        cx := scx-1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx-1,scy].cx*16 +8, pp.y + MineField[scx-1,scy].cy*16 +8);
      with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8);
      end
      else
        IsSchemaFound := False;
    end;


   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11c2(Wsc,Hsc,MFN, sch11a2 ) then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
      if ((MineField[scx,scy].IsClosed)
      or (MineField[scx-1,scy].IsClosed)
      or (MineField[scx+1,scy].IsClosed)) then
     begin
     with MineField[scx,scy] do
     begin
       cx := scx;
       cy := scy;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    with MineField[scx-1,scy] do
      begin
        cx := scx-1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx-1,scy].cx*16 +8, pp.y + MineField[scx-1,scy].cy*16 +8);
      with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8);
       end
      else
        IsSchemaFound := False;
    end;



   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11c2(Wsc,Hsc,MFN, sch11a2 ) then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
      if ((MineField[scx,scy].IsClosed)
      or (MineField[scx-1,scy].IsClosed)
      or (MineField[scx+1,scy].IsClosed)) then
     begin
     with MineField[scx,scy] do
     begin
       cx := scx;
       cy := scy;
       IsClosed := False;
     end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    with MineField[scx-1,scy] do
      begin
        cx := scx-1;
        cy := scy;
        IsClosed := False;
       end;                      ;
      SendClick_v1(HWinMine, pp.x + MineField[scx-1,scy].cx*16 +8, pp.y + MineField[scx-1,scy].cy*16 +8);
      with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8);
      end
      else
        IsSchemaFound := False;
   end;



  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema11b1(Wsc,Hsc,MFN, sch11b1) then
  begin
    scx := wsc;
    scy := hsc;
    IsSchemaFound := True;
    pp := GetFieldScreenOrigine(HWinMine);
    SetForegroundWindow(HWinMine);
     if ((MineField[scx,scy].IsClosed)
     or (MineField[scx,scy-1].IsClosed)
     or (MineField[scx,scy+1].IsClosed)) then
     begin
    with MineField[scx,scy] do
    begin
      cx := scx;
      cy := scy;
      IsClosed := False;
    end;
    SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    with MineField[scx,scy-1] do
      begin
        cx := scx;
        cy := scy-1;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx,scy-1].cx*16 +8, pp.y + MineField[scx,scy-1].cy*16 +8);
      with MineField[scx,scy+1] do
      begin
        cx := scx;
        cy := scy+1;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx,scy+1].cx*16 +8, pp.y + MineField[scx,scy+1].cy*16 +8);
      end
      else
        IsSchemaFound := False;
  end;

   GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema11b2(Wsc,Hsc,MFN, sch11b2) then
  begin
    scx := wsc;
    scy := hsc;
    IsSchemaFound := True;
    pp := GetFieldScreenOrigine(HWinMine);
    SetForegroundWindow(HWinMine);
     if ((MineField[scx,scy].IsClosed) or
     (MineField[scx,scy-1].IsClosed) or
     (MineField[scx,scy+1].IsClosed)) then
     begin
    with MineField[scx,scy] do
    begin
      cx := scx;
      cy := scy;
      IsClosed := False;
    end;
    SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    with MineField[scx,scy-1] do
      begin
        cx := scx;
        cy := scy-1;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx,scy-1].cx*16 +8, pp.y + MineField[scx,scy-1].cy*16 +8);
      with MineField[scx,scy+1] do
      begin
        cx := scx;
        cy := scy+1;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx,scy+1].cx*16 +8, pp.y + MineField[scx,scy+1].cy*16 +8);
     end
      else
        IsSchemaFound := False;
  end;

   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11a1(Wsc,Hsc,MFN, sch11a1) = True then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
      if ((MineField[scx,scy].IsClosed) or
      (MineField[scx-1,scy].IsClosed) or
      (MineField[scx+1,scy].IsClosed)) then
     begin
     with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := False;
       end;
     SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
     with MineField[scx-1,scy] do
      begin
        cx := scx-1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx-1,scy].cx*16 +8, pp.y + MineField[scx-1,scy].cy*16 +8);
      with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8);
      end
      else
        IsSchemaFound := False;
   end;

   GetMineFieldNumeriq(MFN, MineField);
   if Cherche2Schema11a2(Wsc,Hsc,MFN, sch11a2) = True then
   begin
     scx := wsc;
     scy := hsc;
     IsSchemaFound := True;
     pp := GetFieldScreenOrigine(HWinMine);
     SetForegroundWindow(HWinMine);
      if ((MineField[scx,scy].IsClosed)
      or (MineField[scx-1,scy].IsClosed)
      or (MineField[scx+1,scy].IsClosed)) then
     begin
     with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := False;
       end;
    SendClick_v1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
     with MineField[scx-1,scy] do
      begin
        cx := scx-1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx-1,scy].cx*16 +8, pp.y + MineField[scx-1,scy].cy*16 +8);
      with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;    
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8); 
     end
      else
        IsSchemaFound := False;
   end;

{-----------------------Schema 121----------------------------------------------------}


  GetMineFieldNumeriq(MFN, MineField);
  if Cherche2Schema121d(Wsc,Hsc, MFN, sch121d) = True then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;

    with MineField[scx+2,scy] do
      begin
        cx := scx+2;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;
   if GetMark(MineField[scx+2,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx+2,scy].cx*16 +8, pp.y + MineField[scx+2,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8);
      sleep(1000);

  end;

  {-----------Schema121c-------------------------------------------------------}
  GetMineFieldNumeriq(MFN, MineField);
  // InitTMAP(MAP, MFN);

  if Cherche2Schema121c(Wsc,Hsc, MFN, sch121c) = True then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);

    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx+2,scy] do
      begin
        cx := scx+2;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;
    if GetMark(MineField[scx+2,scy].cx,MineField[scx+2,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx+2,scy].cx*16 +8, pp.y + MineField[scx+2,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx+1,scy] do
      begin
        cx := scx+1;
        cy := scy;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx+1,scy].cx*16 +8, pp.y + MineField[scx+1,scy].cy*16 +8);

  end;

  {-----------Schema121b-------------------------------------------------------}
   GetMineFieldNumeriq(MFN, MineField);
  // InitTMAP(MAP, MFN);
  if Cherche2Schema121b(Wsc,Hsc, MFN, sch121b) = True then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);
 {Form2.label1.caption := 'width: '+ inttostr(wsc) + ' Height: ' +inttostr(hsc);
  form2.showmodal;  }
   if MineField[scx-2,scy].IsClosed = False and
     MineField[scx-2,scy+1].IsClosed = False and
     MineField[scx-2,scy+2].IsClosed = False
  then
  begin
    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx,scy+2] do
      begin
        cx := scx;
        cy := scy+2;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;
    if GetMark(MineField[scx,scy+2].cx,MineField[scx,scy+2].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy+2].cx*16 +8, pp.y + MineField[scx,scy+2].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx,scy+1] do
      begin
        cx := scx;
        cy := scy+1;
        IsClosed := False;
       end;
      SendClick_v1(HWinMine, pp.x + MineField[scx,scy+1].cx*16 +8, pp.y + MineField[scx,scy+1].cy*16 +8);

  end;
  end;

  {-----------Schema121a-------------------------------------------------------}
   GetMineFieldNumeriq(MFN, MineField);
  // InitTMAP(MAP, MFN);
  if Cherche2Schema121a(Wsc,Hsc, MFN, sch121a) = True then
  begin
  scx := wsc;
  scy := hsc;
  IsSchemaFound := True;
  pp := GetFieldScreenOrigine(HWinMine);
  SetForegroundWindow(HWinMine);
  if MineField[scx+2,scy].IsClosed = False and
     MineField[scx+2,scy+1].IsClosed = False and
     MineField[scx+2,scy+2].IsClosed = False
  then
  begin
    with MineField[scx,scy] do
      begin
        cx := scx;
        cy := scy;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;

    if GetMark(MineField[scx,scy].cx,MineField[scx,scy].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy].cx*16 +8, pp.y + MineField[scx,scy].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx,scy+2] do
      begin
        cx := scx;
        cy := scy+2;
        IsClosed := True;
        cMarked :=  msMineMark;
      end;
    if GetMark(MineField[scx,scy+2].cx,MineField[scx,scy+2].cy) = 0 then
    begin
    SendRightClick1(HWinMine, pp.x + MineField[scx,scy+2].
    cx*16 +8, pp.y + MineField[scx,scy+2].cy*16 +8);
    Inc(NbCellMarked);
    end;
    with MineField[scx,scy+1] do
      begin
        cx := scx;
        cy := scy+1;
        IsClosed := False;
       end;    
      SendClick_v1(HWinMine, pp.x + MineField[scx,scy+1].cx*16 +8, pp.y + MineField[scx,scy+1].cy*16 +8);

   end;
   end;

  if IsSchemaFound = True then
  begin
    IsSchemaFound := False;
    //inc(boucle2);  //showmessage('toto');
    goto debut;
  end;


    /ClickIntelligent2 ;

 if  IsFinish(Combobox1.ItemIndex, IsWinner) then exit;

  inc(boucle2);
  goto debut;
  end;

procedure TForm1.Button8Click(Sender: TObject);
var
  scores: TScoresTab;
begin
  ReadScore(HWInMine,scores);
  lbDebTime.Caption := scores[1].TimeElapsed;
  lbDebWin.Caption := scores[1].Winner;
  lbIntTime.Caption := scores[2].TimeElapsed;
  lbIntWin.Caption := scores[2].Winner;
  lbExpTime.Caption := scores[3].TimeElapsed;
  lbExpWin.Caption := scores[3].Winner;
end;



procedure TForm1.Button9Click(Sender: TObject);
begin
Form1.Close;
end;

procedure TForm1.ShowHideClick(Sender: TObject);
begin
  if ShowHide.tag = 0 then
  begin
    ShowHide.tag := 1;
    ShowHide.caption := '<<<';
    Form1.Width := 616;
  end
  else
  begin
    ShowHide.tag := 0;
    ShowHide.caption := '>>>';
    Form1.Width := 380;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  form1.memo1.Clear;
  GetMineFieldNumeriq(MFN, MineField);
  InitTMAP(MAP, MFN);
  AfficheMAP(MAP, form1.memo1);
  //ChercheSchema(MAP, sch);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
showmessage(inttostr(sizeof(sch121d[1])));
end;

Initialization
  nbrepartiesgagnees :=0;
  HWinmine           :=0;
  NbrePartiesJouees  :=0;
  ScoreCumule        :=0;
  MoyenneScore       :=0;
  tpsmoyen           :=0;
  tps                :=0;
  hsc                :=0;
  wsc                :=0;
end.


